
var pathToRegexp = require('path-to-regexp')

function hashpath() {
	// cut prefix '#'
	return window.location.hash.slice(1)
}

if (!String.prototype.startsWith) {
	String.prototype.startsWith = function(searchString, position) {
		position = position || 0
		return this.lastIndexOf(searchString, position) === position
	};
}

var dispatcher = (function () {
	var object = {
		hashCurrent: hashpath(),
		hashPrevious: '',
		hashRoutes: [],
	}

	object.hash = function (path, arg) {
		if (path === undefined) throw new TypeError('invalid argument arg[1:path]')
		if (arg === undefined) throw new TypeError('invalid argument arg[2:arg]')

		var keys = []
		var re = pathToRegexp(path, keys)

		var route = {
			re: re,
			keys: keys,
		}

		route.callback = arg

		object.hashRoutes.push(route)
	}

	object.dispatch = function (path) {
		if (!path) {
			path = hashpath()
		}
		else {
			object.hashPrevious = object.hashCurrent
			object.hashCurrent = path
		}

		var routes = object.hashRoutes
		for (var index = 0; index < routes.length; ++index) {
			var route = routes[index]
			var result = route.re.exec(path)
			if (result) {
				route.callback.apply(object, result.slice(1))
				return
			}
		}
	}

	object.emit = function () {
	}

	function changeHash(e) {
//		console.log('changeHash', e)
		router.dispatch()
	}

	object.start = function () {
		window.addEventListener('popstate', changeHash)
		window.addEventListener('hashchange', changeHash)
	}

	object.stop = function () {
		window.removeEventListener('hashchange', changeHash)
		window.removeEventListener('popstate', changeHash)
	}

	return object
}())

module.exports = dispatcher
